SELECT TOP 500 
  execution_count AS total_exec_count, 
  stat.total_worker_time/1000 AS total_cpu_ms, 
  stat.total_elapsed_time/1000 AS total_duration_ms, 
  stat.total_physical_reads AS total_physical_reads, 
  stat.total_logical_writes AS total_logical_writes, 
  stat.total_logical_reads AS total_logical_reads, 
  LEFT (CASE 
    WHEN pa.value=32767 THEN 'ResourceDb'
    ELSE ISNULL (DB_NAME (CONVERT (sysname, pa.value)), CONVERT (sysname, pa.value))
  END, 40) AS dbname, 
  sql.objectid, 
  CONVERT (nvarchar(60), CASE  
    WHEN sql.objectid IS NULL THEN NULL 
    ELSE REPLACE (REPLACE (LEFT (sql.[text], 60), CHAR(13), ' '), CHAR(10), ' ')
  END) AS procname, 
  CONVERT (nvarchar(2000), REPLACE (REPLACE (SUBSTRING (sql.[text], stat.statement_start_offset/2 + 1, 
      CASE WHEN stat.statement_end_offset = -1 THEN 8192 
      ELSE stat.statement_end_offset/2 - stat.statement_start_offset/2 END + 1), 
    CHAR(13), ' '), CHAR(10), ' ')) AS stmt_text, 
  CONVERT (varchar (130), master.dbo.fn_varbintohexstr (stat.plan_handle)) AS plan_handle
FROM sys.dm_exec_query_stats stat 
OUTER APPLY sys.dm_exec_plan_attributes (stat.plan_handle) pa
OUTER APPLY sys.dm_exec_sql_text (stat.sql_handle) AS sql
WHERE pa.attribute = 'dbid' 
ORDER BY stat.total_worker_time DESC
