if exists (select * from sys.objects where name = 'scheduler_health_monitor_xml')
	drop table scheduler_health_monitor_xml
go

select convert(XML, record) as xml_record
into scheduler_health_monitor_xml
from sys.dm_os_ring_buffers
where ring_buffer_type = 'RING_BUFFER_SCHEDULER_MONITOR'
go

select 
	xml_record.value ('(/Record/@id)[1]', 'int') as RecordId,
	sh.value ('(ProcessUtilization)[1]', 'int') as ProcessUtil,
	sh.value ('(SystemIdle)[1]', 'int') as SystemIdle,
	sh.value ('(PageFaults)[1]', 'int') as PageFaults,
	sh.value ('(WorkingSetDelta)[1]', 'int') as WorkingSetDelta,
	sh.value ('(MemoryUtilization)[1]', 'int') as MemoryUtilPct
from 
	scheduler_health_monitor_xml cross apply xml_record.nodes('/Record/SchedluerMonitorEvent/SystemHealth') scheduler_health(sh)
where
	sh.exist ('(/Record/SchedluerMonitorEvent/SystemHealth)') = 1
order by
	RecordId desc
go
